{-# LANGUAGE DerivingVia #-}

module Lib
  ( runBothServers,
  )
where

import ClassyPrelude
import State.ConnectedClientsState (initConnectionsState)
import State.RoomsState (initRoomsState)
import Types.AppTypes
import Types.Config (ServerOptions)
import WebServer (runWebServer)
import WebSocket.Server (runWebSocketServer)

runBothServers :: ServerOptions -> IO ()
runBothServers serverOptions = do
  connectedClientsState <- initConnectionsState
  roomsState <- initRoomsState

  let env =
        Env
          { connectedClientsState = connectedClientsState,
            profile = Dev,
            roomsState = roomsState,
            config = serverOptions
          }

  _ <- concurrently (unApp runWebSocketServer env) (unApp runWebServer env)
  return ()
