export interface ConferenceData {
  roomName: string // the room name of the conference
  id: string // the id of the local participant
  displayName: string // the display name of the local participant
  avatarURL: string // the avatar URL of the local participant
  breakoutRoom: boolean // whether the current room is a breakout room
}

export interface DisplayNameChangeEvent {
  id: string // the id of the participant that changed their display name
  displayname: string // the new display name (WTF why is capilization different)
}

function videoConferenceJoinedListener(
  setConferenceData: (newData: ConferenceData) => void,
  videoConferenceJoinedEvent: ConferenceData
) {
  setConferenceData(videoConferenceJoinedEvent)
}

function displayNameChangeListenerWrapper(
  setDisplayNameChangedEvent: (newData: DisplayNameChangeEvent) => void,
  displayNameChangeEvent: DisplayNameChangeEvent
) {
  setDisplayNameChangedEvent(displayNameChangeEvent)
}

function displayNameChangeListener(
  conferenceData: ConferenceData | undefined,
  setConferenceData: (newData: ConferenceData) => void,
  displayNameChangeEvent: DisplayNameChangeEvent
) {
  console.log('[Rooms] displayNameChangeListener', displayNameChangeEvent, conferenceData)
  if (conferenceData && conferenceData.id == displayNameChangeEvent.id)
    setConferenceData({
      ...conferenceData,
      displayName: displayNameChangeEvent.displayname,
    } as ConferenceData)
}

export {
  videoConferenceJoinedListener,
  displayNameChangeListenerWrapper,
  displayNameChangeListener,
}
